---
title: "Statistical analyses and graphics"
Author: Méline Saubin
output: html_document
---

From data tables obtained from python and R scripts, this R script allows us to perform statistical analyses and to output the graphics.

The python scripts **Model_resistance_durability_diploid.py** and **Model_resistance_durability_haploid.py** were run previously for 4 quantitative parameters (favr, r, mig and propR), 2 modalities of qualitative parameters cycle (with and without host alternation), and at least 100 replicates for each combinations for three distinct experimental designs:

- The random experimental design:
**random_design.csv** corresponds to the concatenation of the 2 files **Generation.txt** which originate from the python scripts **Transformation_python_results_dip.py** and **Transformation_python_results_hap.py**, based on results from the python sripts **Model_resistance_durability_diploid.py** and **Model_resistance_durability_haploid.py**.

- The regular experimental design:
**Fixation.txt** originates from the python scripts **Transformation_python_results_dip.py** or **Transformation_python_results_hap.py** (depending on the ploidy considered), based on results from the python sripts **Model_resistance_durability_diploid.py** or **Model_resistance_durability_haploid.py**.

- The restricted experimental design:
**Indices_seuil.csv** and **Tableau_donnees.csv** originate from the R script **Restricted_experimental_design_transfo.Rmd**, based on the intermediate *results* files obtained from the python sripts **Model_resistance_durability_diploid.py** or **Model_resistance_durability_haploid.py** when donnees_intermediaires=="oui".


```{r setup, include=FALSE}
# R version 4.0.3 (2020-10-10)

knitr::opts_chunk$set(echo = TRUE)
library(ggplot2)    # Version 3.3.3
library(car)        # Version 3.0.10
library(gridExtra)  # Version 2.3

library(MBA)        # Version 0.0.9
library(akima)      # Version 0.6.2.1
library(bamlss)     # Version 1.1.3

library(ade4)       # Version 1.7.16 # PCA
library(factoextra) # Version 1.0.7 # PCA Graphics
library(viridis)    # Version 0.6.0 # Colors
library(sensitivity)        # Version 1.25.0 # Sobol indices
library(dominanceanalysis)  # Version 2.0.0 # Dominance analyses on glm
```

# Data importation

## Random experimental design

Each row of the input files must correspond to 1 replicate: the 6 parameters followed by the result of the simulation with extinction (1 ou 0) fixation of the virulent allele (1 ou 0) and the generation of fixation (NA if fixation = 0).

*frequence* stands for favr, ploidie stands for ploidy, *avec_meleze* stands for with host alternation, and *sans_meleze* stands for without host alternation.

```{r Import of the random experimental design}
directory_random = "/Model_Resistance_Durability/Data/" 

Tableau <- read.table(paste(directory_random,"Random_design.csv",sep=""), header = TRUE, sep = ";", dec = ",")

# Transformation of qualitatives into factors : 
Tableau$cycle = as.factor(Tableau$cycle)
Tableau$ploidie = as.factor(Tableau$ploidie)

# Implementation of a summary table, with one row per combination of parameters
Tableau_resume = aggregate(Tableau[, c(7,8)], list(frequence = Tableau$frequence, mig = Tableau$mig, r = Tableau$r, propR = Tableau$propR, cycle = Tableau$cycle, ploidie = Tableau$ploidie), sum)
Tableau_resume_gen_mean = aggregate(Tableau[, c(9)], list(frequence = Tableau$frequence, mig = Tableau$mig, r = Tableau$r, propR = Tableau$propR, cycle = Tableau$cycle, ploidie = Tableau$ploidie), mean, na.rm=TRUE)
colnames(Tableau_resume_gen_mean)[7]<- "gen_fix_moy"
Tableau_resume_gen_var = aggregate(Tableau[, c(9)], list(frequence = Tableau$frequence, mig = Tableau$mig, r = Tableau$r, propR = Tableau$propR, cycle = Tableau$cycle, ploidie = Tableau$ploidie), var, na.rm=TRUE)
colnames(Tableau_resume_gen_var)[7]<- "gen_fix_var"

Tableau_resume = merge(x = Tableau_resume, y = Tableau_resume_gen_mean, by = c("frequence", "r", "mig", "propR","cycle","ploidie"), all = TRUE)
Tableau_resume = merge(x = Tableau_resume, y = Tableau_resume_gen_var, by = c("frequence", "r", "mig", "propR","cycle","ploidie"), all = TRUE)

# Add the column fix_avirulence (fixation of the avirulent allele) 
Tableau_resume$fix_avirulence = 100-Tableau_resume$extinction-Tableau_resume$fix_virulence
```

## Regular experimental design

For the regular experimental design, the data must be transformed first by the Python script **Transformation_python_results_dip.py** or **Transformation_python_results_hap.py** (depending on the ploidy considered) to obtain the file Fixation.txt.

Each row corresponds to a unique combination of parameters, with the summarized results for 100 replicates:

*frequence* stands for favr, *avec_meleze* with host alternation, *sans_meleze* without host alternation, *KR* stands for the carrying capacity on R (propR = KR/100000), *freq_fix_C* the frequency of fixation of the virulent allele avr among replications, *gen_fix_C* the mean generation of fixation of avr among replicates, *freq_ext* the frequency of extinctions, *gen_ext* the mean generation of extinction, *freq_fix_T* the frequency of fixation of the avirulent allele Avr, *gen_fix_T* the generation of fixation of Avr, and *freq_eq* the frequency of coexistences of avr and Avr.
*gen_prem_vir* stands for the mean first generation of observation of a virulent individual, *gen_prem_R* the mean first generation of observation of an individual on the R compartment, Q025, Q50 and Q975 the quantiles 0.025, 0.5 and 0.975 of the generation of fixations and extinctions, *var_prem_vir* the variance in the first generation of observation of a virulent individual, and *var_prem_R* the variance in the first generation of observation of an individual on the R compartment.

```{r Import of the regular experimental design}
directory_regular = "/Model_Resistance_Durability/Data/Regular_design/" 

############ Diploid simulations
Tableau_fixation_dip_1 = read.table(paste(directory_regular,'Plan_nv_logistique_mig_dip/Tableaux/Fixation.txt', sep=""), header = T)
Tableau_fixation_dip_2 = read.table(paste(directory_regular,'Plan_nv_logistique_dip_propR_0-1_0-9/Tableaux/Fixation.txt', sep=""), header = T)

Tableau_fixation_dip = rbind(Tableau_fixation_dip_1,Tableau_fixation_dip_2)


############ Haploid simulations
Tableau_fixation_hap_1 = read.table(paste(directory_regular,'Plan_nv_logistique_mig_hap/Tableaux/Fixation.txt', sep=""), header = T)
Tableau_fixation_hap_2 = read.table(paste(directory_regular,'Plan_nv_logistique_hap_propR_0-1_0-9/Tableaux/Fixation.txt', sep=""), header = T)

Tableau_fixation_hap = rbind(Tableau_fixation_hap_1,Tableau_fixation_hap_2)


Tableau_fixation_dip$ploidie="dip"
Tableau_fixation_hap$ploidie="hap"

Tableau_fixation = rbind(Tableau_fixation_dip,Tableau_fixation_hap)

Tableau_fixation$propR = Tableau_fixation$KR/100000
```

## Restricted experimental design

For the restricted experimental design, the data must be transformed first by the R script **Restricted_experimental_design_transfo.Rmd** for each combination of parameters, to obtain 12 files **Indice_Seuil.csv** and 12 files **Tableau_donnees.csv** imported therafter.

### Year of invasion (or resistance breakdown)

Here, the code is adapted to the restricted design for diploids, mig = 0.05, and the threshold of invasion (as opposed to resistance breakdown). To study the results for haploids, mig=0.001 or the threshold of resistance breakdown, just replace with the correct directories.

Each row corresponds to one replicate:
*LISTE_indices* stands for the year of invasion (or resistance breakdown depending of the source file) and *LISTE_GENERATIONS* corresponds to the year of fixation of the virulent allele.


```{r Import of the restricted experimental design (year of invasion)}
directory_restricted = '/Model_Resistance_Durability/Data/Restricted_design/'

# Importation of one data file for each parameters combinations

# Diploids
DIP_K10_90_C1 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K10-90_r1-5_M0-05_C1/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
DIP_K10_90_C2 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K10-90_r1-5_M0-05_C2/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
DIP_K50_50_C1 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K50-50_r1-5_M0-05_C1/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
DIP_K50_50_C2 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K50-50_r1-5_M0-05_C2/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
DIP_K90_10_C1 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K90-10_r1-5_M0-05_C1/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
DIP_K90_10_C2 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K90-10_r1-5_M0-05_C2/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))

# haploids
HAP_K10_90_C1 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K10-90_r1-5_M0-05_C1_hap/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
HAP_K10_90_C2 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K10-90_r1-5_M0-05_C2_hap/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
HAP_K50_50_C1 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K50-50_r1-5_M0-05_C1_hap/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
HAP_K50_50_C2 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K50-50_r1-5_M0-05_C2_hap/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
HAP_K90_10_C1 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K90-10_r1-5_M0-05_C1_hap/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
HAP_K90_10_C2 = read.csv2(paste(directory_restricted, 'Resultat_V0-02_K90-10_r1-5_M0-05_C2_hap/Avant_sexe/Indices_seuil.csv', sep=""), sep = "t", col.names=c("RB", "FIXATION"))
```

New columns corresponding to the parameters: *ploidy*, *propR* and *cycle*

```{r Adaptation of the restricted experimental design tables (year of invasion)}
# Ploidy column: "hap" for haploids and "dip" for diploids
DIP_K10_90_C1$ploidie = as.factor("dip")
DIP_K10_90_C2$ploidie = as.factor("dip")
DIP_K50_50_C1$ploidie = as.factor("dip")
DIP_K50_50_C2$ploidie = as.factor("dip")
DIP_K90_10_C1$ploidie = as.factor("dip")
DIP_K90_10_C2$ploidie = as.factor("dip")
HAP_K10_90_C1$ploidie = as.factor("hap")
HAP_K10_90_C2$ploidie = as.factor("hap")
HAP_K50_50_C1$ploidie = as.factor("hap")
HAP_K50_50_C2$ploidie = as.factor("hap")
HAP_K90_10_C1$ploidie = as.factor("hap")
HAP_K90_10_C2$ploidie = as.factor("hap")

# propR column
DIP_K10_90_C1$KR = 0.9
DIP_K10_90_C2$KR = 0.9
DIP_K50_50_C1$KR = 0.5
DIP_K50_50_C2$KR = 0.5
DIP_K90_10_C1$KR = 0.1
DIP_K90_10_C2$KR = 0.1
HAP_K10_90_C1$KR = 0.9
HAP_K10_90_C2$KR = 0.9
HAP_K50_50_C1$KR = 0.5
HAP_K50_50_C2$KR = 0.5
HAP_K90_10_C1$KR = 0.1
HAP_K90_10_C2$KR = 0.1

# Cycle column: "With_alt" for with host alternation and "Without_alt" for without host alternation
DIP_K10_90_C1$cycle = as.factor("With host alternation")
DIP_K10_90_C2$cycle = as.factor("Without host alternation")
DIP_K50_50_C1$cycle = as.factor("With host alternation")
DIP_K50_50_C2$cycle = as.factor("Without host alternation")
DIP_K90_10_C1$cycle = as.factor("With host alternation")
DIP_K90_10_C2$cycle = as.factor("Without host alternation")
HAP_K10_90_C1$cycle = as.factor("With host alternation")
HAP_K10_90_C2$cycle = as.factor("Without host alternation")
HAP_K50_50_C1$cycle = as.factor("With host alternation")
HAP_K50_50_C2$cycle = as.factor("Without host alternation")
HAP_K90_10_C1$cycle = as.factor("With host alternation")
HAP_K90_10_C2$cycle = as.factor("Without host alternation")

# New variable: VIT_FIX = number of years between the invasion and the fixation of the virulent allele.

DIP_K10_90_C1$VIT_FIX = DIP_K10_90_C1$FIXATION-DIP_K10_90_C1$RB
DIP_K10_90_C2$VIT_FIX = DIP_K10_90_C2$FIXATION-DIP_K10_90_C2$RB
DIP_K50_50_C1$VIT_FIX = DIP_K50_50_C1$FIXATION-DIP_K50_50_C1$RB
DIP_K50_50_C2$VIT_FIX = DIP_K50_50_C2$FIXATION-DIP_K50_50_C2$RB
DIP_K90_10_C1$VIT_FIX = DIP_K90_10_C1$FIXATION-DIP_K90_10_C1$RB
DIP_K90_10_C2$VIT_FIX = DIP_K90_10_C2$FIXATION-DIP_K90_10_C2$RB
HAP_K10_90_C1$VIT_FIX = HAP_K10_90_C1$FIXATION-HAP_K10_90_C1$RB
HAP_K10_90_C2$VIT_FIX = HAP_K10_90_C2$FIXATION-HAP_K10_90_C2$RB
HAP_K50_50_C1$VIT_FIX = HAP_K50_50_C1$FIXATION-HAP_K50_50_C1$RB
HAP_K50_50_C2$VIT_FIX = HAP_K50_50_C2$FIXATION-HAP_K50_50_C2$RB
HAP_K90_10_C1$VIT_FIX = HAP_K90_10_C1$FIXATION-HAP_K90_10_C1$RB
HAP_K90_10_C2$VIT_FIX = HAP_K90_10_C2$FIXATION-HAP_K90_10_C2$RB
```
 
Merging all tables into one single table DONNEES_12_PARAMS

```{r Merging of all restricted experimental design tables (year of invasion)}
DONNEES_12_PARAMS = rbind(DIP_K10_90_C1,DIP_K10_90_C2,DIP_K50_50_C1,DIP_K50_50_C2,DIP_K90_10_C1,DIP_K90_10_C2,HAP_K10_90_C1,HAP_K10_90_C2,HAP_K50_50_C1,HAP_K50_50_C2,HAP_K90_10_C1,HAP_K90_10_C2)

# Removal of every replicate without virulence fixation
DONNEES_12_PARAMS = subset(DONNEES_12_PARAMS, !is.na(FIXATION))
```

### Evolution of population sizes and allele proportions 

Here, the code is adapted to the restricted design for diploids, with host alternation and propR=0.9. To study the results for other parameters combinations, just replace with the correct directory.

Each row corresponds to one generation:
*rep* stands for the replicate ID, *gen* for the scaled generation (generation = 0 at the invasion),  *PropC* for the proportion of virulent alleles, *Taille_pop_S* and *Taille_pop_S* for the population sizes on S and R, respectively.

```{r Import of the restricted experimental design (evolution through time)}
TABLEAU = read.table(paste(directory_restricted, "Resultat_V0-02_K10-90_r1-5_M0-05_C2/Avant_sexe/Tableau_donnees.csv", sep = ""), sep="t",dec=",", na="NA", skip = 1,col.names=c("rep", "gen", "Taille_pop_S", "Taille_pop_R", "PropC"))
```

## Directory for figure export

```{r Directory for figure export}
directory_figures = "/media/msaubin/SAUBIN/Modelisation/Data/" 
```

# Statistical analyses

## PCA based on the random design

```{r PCA analysis}
# Replacement of NaN on the generation by the mean value of fixation generation
Tableau_resume_sansNA <- Tableau_resume
  
mean_mean_gen_fix <- mean(Tableau_resume_sansNA[,"gen_fix_moy"], na.rm = T)
mean_var_gen_fix <- mean(Tableau_resume_sansNA[,"gen_fix_var"], na.rm = T)

Tableau_resume_sansNA$gen_fix_moy[is.na(Tableau_resume_sansNA$gen_fix_moy)] = mean_mean_gen_fix
Tableau_resume_sansNA$gen_fix_var[is.na(Tableau_resume_sansNA$gen_fix_var)] = mean_var_gen_fix

# We renamme each parameters to correspond to the paper notations
Tableau_resume_sansNA$favr = Tableau_resume_sansNA$frequence
Tableau_resume_sansNA$freq_fix_avr= Tableau_resume_sansNA$fix_virulence
Tableau_resume_sansNA$freq_fix_Avr= Tableau_resume_sansNA$fix_avirulence
Tableau_resume_sansNA$freq_ext= Tableau_resume_sansNA$extinction
Tableau_resume_sansNA$gen_fix_avr = Tableau_resume_sansNA$gen_fix_moy

################################## Variables ###################################

res.pca = dudi.pca(Tableau_resume_sansNA[,c("freq_ext", "freq_fix_avr","freq_fix_Avr","gen_fix_avr")], scale=T, nf=3,scannf=FALSE) 

sup <-supcol(res.pca,scalewt(Tableau_resume_sansNA[,c("favr", "propR", "r", "mig")]))$cosup

p <- fviz_pca_var(res.pca,
            col.var = "black", 
            #col.var.sup = "blue",
            repel = TRUE,# Avoid text overlapping
            title='',
            alpha.var=0.3
            #label = "none"
            )     
# Additional variables
# To hide labels, add addlabel = FALSE
ACP_params = fviz_add(p, sup, geom="arrow", linetype='solid', color ="darkturquoise", repel = TRUE, alpha=0.3)

# Export in PDF
pdf(paste(directory_figures,"PCA_var.pdf",sep=""), width = 5, height = 5)
  ACP_params
dev.off()

################################# Individuals ##################################

# Addition of colors depending on the life cycle and the ploidy 

Tableau_resume_sansNA$cycle_ploidie = ifelse(Tableau_resume_sansNA$cycle=="sans_meleze", ifelse(Tableau_resume_sansNA$ploidie=="hap","Haploid, Without alt", "Diploid, Without alt"),ifelse(Tableau_resume_sansNA$ploidie=="hap","Haploid, With alt", "Diploid, With alt"))

CyclePloidie <- as.factor(Tableau_resume_sansNA$cycle_ploidie)

ind = fviz_pca_biplot(res.pca,
             col.ind = CyclePloidie, # colored by group
             palette = c("indianred2",  "darkgoldenrod1", "turquoise3", "seagreen3"),
             col.var = "black",
             addEllipses = TRUE, 
             ellipse.type = "t",
             ellipse.level = 0.95,
             #ellipse.type = "confidence",
             legend.title = "Ploidy, Cycle",
             label = c("var"),
             #repel = TRUE,
             title=""
             #label =  c("with alternate host diploid",  "with alternate host haploid", "without alternate host dilpoid", "without alternate host haploid")
             )

# Export in PDF
pdf(paste(directory_figures,"PCA_ind.pdf",sep=""), width = 5, height = 5)
  ind
dev.off()
```

## Dominance analyses based on the random design

Warning, dominance analysis based on bootstraps can take a long time to run (several hours on 1 CPU for the generation of fixation).

### Extinction analysis

```{r Dominance analysis on the proportion of extinction of populations}
# Addition of the number of survival of population for each parameters combinations (over 100 replicates in our simulations)
Tableau_resume$survie <- (100-Tableau_resume$extinction)

# glm with a binomial law
extinction_glm <- glm(cbind(extinction,survie) ~  frequence + r +  mig + propR + cycle + ploidie , data=Tableau_resume, family=binomial(logit))

summary(extinction_glm)

Anova(extinction_glm, type = "II",test = "Wald", error.estimate="deviance")
anova(extinction_glm)

# Dominance analysis with a bootstrap of 100 for the precision intervals
bootavemodpres100<-bootAverageDominanceAnalysis(extinction_glm,R=100)
boot_glm_ext = summary(bootavemodpres100,fit.functions=c("r2.m"))$r2.m

p1 = eval(substitute(ggplot(boot_glm_ext) +
    geom_bar( aes(x=Var, y=bs.E), stat="identity", fill="skyblue", alpha=0.7) +
    geom_errorbar( aes(x=Var, ymin=bs.E-bs.SE, ymax=bs.E+bs.SE), width=0.2, colour="black", alpha=0.9, size=0.3)+
    xlab("")+
    ylab("Estimated general dominance")+
    labs(title="Frequency of extinction")+
    scale_x_discrete(labels=c("cycle","favr","mig","ploidy","propR","r"))+
    ylim(c(0,0.65))+
    theme_minimal()))

pdf(paste(directory_figures,"Dominance_Analysis_Ext.pdf",sep=""), width = 3, height = 3)
  p1
dev.off()
```

### Fixation of avr, among surviving populations

```{r Dominance analysis on the proportion of fixation of the virulent allele}
# We remove from the table all rows with 100% population extinction
Tableau_resume_glm_fix <- subset(Tableau_resume, extinction != 100)

# glm with a binomial law
fixation_glm <- glm(cbind(fix_virulence,survie-fix_virulence) ~  frequence + r +  mig + propR + cycle + ploidie , data=Tableau_resume_glm_fix, family=binomial(logit))

summary(fixation_glm)

Anova(fixation_glm, type = "II",test = "Wald")

# Dominance analysis with a bootstrap of 100 for the precision intervals
bootavemodpres100_fix_2<-bootAverageDominanceAnalysis(fixation_glm,R=100)
boot_glm_fix = summary(bootavemodpres100_fix_2,fit.functions=c("r2.m"))$r2.m

p2 = eval(substitute(ggplot(boot_glm_fix) +
    geom_bar( aes(x=Var, y=bs.E), stat="identity", fill="skyblue", alpha=0.7) +
    geom_errorbar( aes(x=Var, ymin=bs.E-bs.SE, ymax=bs.E+bs.SE), width=0.2, colour="black", alpha=0.9, size=0.3)+
    xlab("")+
    ylab("Estimated general dominance")+
    labs(title="Frequency of avr fixation")+
    scale_x_discrete(labels=c("cycle","favr","mig","ploidy","propR","r"))+
    ylim(c(0,0.25))+
    theme_minimal()))

pdf(paste(directory_figures,"Dominance_Analysis_Fix.pdf",sep=""), width = 3, height = 3)
  p2
dev.off()
```

### Generation of fixation

```{r Dominance analysis on the generation of fixation of the virulent allele}
# We consider the initial Tablen with 1 row for each replicate, removing replicates without avr fixation (therefore without generation of fixation)
tableau_glm_gen_fix <- subset(Tableau, !is.na(gen_fix))

# glm with a gamma law
gen_fix_glm <- glm(gen_fix ~  frequence + r +  mig + propR + cycle + ploidie ,family=Gamma(link="log"),  data=tableau_glm_gen_fix)

summary(gen_fix_glm)

anova(gen_fix_glm)

Anova(fixation_glm, type = "II",test = "Wald")

# Dominance analysis with a bootstrap of 100 for the precision intervals
bootavemodpres100_gen_fix<-bootAverageDominanceAnalysis(gen_fix_glm,R=100)
boot_glm_gen_fix = summary(bootavemodpres100_gen_fix,fit.functions=c("r2.m"))$r2.m

p3 = eval(substitute(ggplot(boot_glm_gen_fix) +
    geom_bar( aes(x=Var, y=bs.E), stat="identity", fill="skyblue", alpha=0.7) +
    geom_errorbar( aes(x=Var, ymin=bs.E-bs.SE, ymax=bs.E+bs.SE), width=0.2, colour="black", alpha=0.9, size=0.3)+
    xlab("")+
    ylab("Estimated general dominance")+
    labs(title="Generation of avr fixation")+
    scale_x_discrete(labels=c("cycle","favr","mig","ploidy","propR","r"))+
    ylim(c(0,0.25))+
    theme_minimal()))

pdf(paste(directory_figures,"Dominance_Analysis_Fix_gen.pdf",sep=""), width = 3, height = 3)
  p3
dev.off()
```

## Dominance analyses based on the restricted design

### Year of invasion

```{r Dominance analysis on the year of invasion}
# glm with a gamma law
glm_inv = glm(RB ~  ploidie + KR + cycle, data=DONNEES_12_PARAMS, family = Gamma(link='identity'))

summary(glm_inv)

anova(glm_inv)

Anova(glm_inv, type = "II",test = "Wald")

# Dominance analysis with a bootstrap of 100 for the precision intervals
bootavemodpres100_inv<-bootAverageDominanceAnalysis(glm_inv,R=100)
boot_glm_inv = summary(bootavemodpres100_inv,fit.functions=c("r2.m"))$r2.m

p4 = eval(substitute(ggplot(boot_glm_inv) +
    geom_bar( aes(x=Var, y=bs.E), stat="identity", fill="skyblue", alpha=0.7) +
    geom_errorbar( aes(x=Var, ymin=bs.E-bs.SE, ymax=bs.E+bs.SE), width=0.2, colour="black", alpha=0.9, size=0.3)+
    xlab("")+
    ylab("Estimated general dominance")+
    labs(title="Year of invasion")+
    scale_x_discrete(labels=c("cycle","propR","ploidy"))+
    ylim(c(0,0.65))+
    theme_minimal()))

pdf(paste(directory_figures,"Dominance_Analysis_Invasion.pdf",sep=""), width = 3, height = 3)
  p4
dev.off()
```

### Time between invasion and fixation of the avr allele

```{r Dominance analysis on the time between invasion and fixation of the virulent allele}
# glm with a gamma law
glm_VIT_FIX = glm(VIT_FIX ~  ploidie + KR + cycle, data=DONNEES_12_PARAMS, family = Gamma(link='identity'))

summary(glm_VIT_FIX)

anova(glm_VIT_FIX)

Anova(glm_VIT_FIX, type = "II",test = "Wald")

# Dominance analysis with a bootstrap of 100 for the precision intervals
bootavemodpres100_VIT_FIX<-bootAverageDominanceAnalysis(glm_VIT_FIX,R=100)
boot_glm_VIT_FIX = summary(bootavemodpres100_VIT_FIX,fit.functions=c("r2.m"))$r2.m

p5 = eval(substitute(ggplot(boot_glm_VIT_FIX) +
    geom_bar( aes(x=Var, y=bs.E), stat="identity", fill="skyblue", alpha=0.7) +
    geom_errorbar( aes(x=Var, ymin=bs.E-bs.SE, ymax=bs.E+bs.SE), width=0.2, colour="black", alpha=0.9, size=0.3)+
    xlab("")+
    ylab("Estimated general dominance")+
    labs(title="Years between invasion and \n virulence fixation")+
    scale_x_discrete(labels=c("cycle","propR","ploidy"))+
    ylim(c(0,0.65))+
    theme_minimal()))

pdf(paste(directory_figures,"Dominance_Analysis_VIT_FIX.pdf",sep=""), width = 3, height = 3)
  p5
dev.off()
```

## Sobol indices for the extinction of populations (Random design)

```{r Sobol indices on the proportion of extinction of the population}
n <- 10000
# Two random draws of n combinations of 6 parameters in a uniform law between 0 and 1
X1 <- data.frame(matrix(runif(6 * n), nrow = n))
X2 <- data.frame(matrix(runif(6 * n), nrow = n))

names(X1)[1]<-"frequence"
names(X1)[2]<-"mig"
names(X1)[3]<-"r"
names(X1)[4]<-"propR"
names(X1)[5]<-"ploidie"
names(X1)[6]<-"cycle"

names(X2)[1]<-"frequence"
names(X2)[2]<-"mig"
names(X2)[3]<-"r"
names(X2)[4]<-"propR"
names(X2)[5]<-"ploidie"
names(X2)[6]<-"cycle"

# Lower boundaries
binf =  c(0.0005017, 0.001, 1.1, 0.01095, 1, 1)

# Upper boundaries
bsup = c(0.2997411 , 0.199663, 1.999, 0.98916, 2, 2)

# For each parameter (column), rescaling of the random draw with the correct variation range 
X1[1]= exp(X1[1]*(log(bsup[1])-log(binf[1]))+log(binf[1])) # log-uniform law
X1[2]= exp(X1[2]*(log(bsup[2])-log(binf[2]))+log(binf[2])) # log-uniform law
X1[3]= X1[3]*(bsup[3]-binf[3])+binf[3]
X1[4]= X1[4]*(bsup[4]-binf[4])+binf[4]
X1[5]= ifelse(round(X1[5]+binf[5])==1, "hap", "dip")
X1[6]= ifelse(round(X1[6]+binf[6])==1, "sans_meleze", "avec_meleze")

X2[1]= exp(X2[1]*(log(bsup[1])-log(binf[1]))+log(binf[1]))
X2[2]= exp(X2[2]*(log(bsup[2])-log(binf[2]))+log(binf[2]))
X2[3]= X2[3]*(bsup[3]-binf[3])+binf[3]
X2[4]= X2[4]*(bsup[4]-binf[4])+binf[4]
X2[5]= ifelse(round(X2[5]+binf[5])==1, "hap", "dip")
X2[6]= ifelse(round(X2[6]+binf[6])==1, "sans_meleze", "avec_meleze")

# Predict function based on extinction_glm
prediction_glm_sobol_extinction = function(X){
  X = as.data.frame(X)
  prediction = predict.glm(extinction_glm,X, type = "response")
  return(scale(prediction, scale = FALSE))
}

# Sensitivity analysis
SOBOL_EXTINCTION= sobol2002(model = prediction_glm_sobol_extinction, X1 = X1, X2 = X2, nboot = 100)

pdf(paste(directory_figures,"Sobol_extinction.pdf",sep=""), width = 6, height = 4)
  plot(SOBOL_EXTINCTION, ylab = "Sobol indices", main="test")
dev.off()
```
# Graphics based on the restricted design

## Histograms of invasion years for diploids

```{r Distribution of the year of invasion}
DONNEES_12_PARAMS$propR = factor(DONNEES_12_PARAMS$KR, levels=c("0.9", "0.5", "0.1"))

number <- ggplot(DONNEES_12_PARAMS[DONNEES_12_PARAMS$ploidie=="dip",], aes(x=RB,color=cycle, fill=cycle, y = after_stat(count)))+
  geom_bar(position="identity", alpha=0.3)+
  theme(legend.position="top")+
  scale_x_continuous(breaks = seq(1, 16, by = 1), limits = c(0.5,16.5))+
  ylim(c(0,530))+
  xlab("Year of invasion")+
  ylab("Number of simulations")+
  facet_grid(propR ~ .,labeller = label_both)

pdf(paste(directory_figures,"Indice_seuil_invasion_MIG_0_05.pdf",sep=""), height = 6, width = 4)
  number
dev.off()
```
## Evolution of poulation sizes and allelic frequencies from the invasion

Implementation of lists of medians and quantiles 0.025 and 0.975 for each generation

```{r Quantiles of the proportion of virulent allele and population sizes through time}
Median_PropC = c(rep(NA,length(unique(TABLEAU$gen))))
Q0_025_PropC = c(rep(NA,length(unique(TABLEAU$gen))))
Q0_975_PropC = c(rep(NA,length(unique(TABLEAU$gen))))

Median_TailleS = c(rep(NA,length(unique(TABLEAU$gen))))
Q0_025_TailleS = c(rep(NA,length(unique(TABLEAU$gen))))
Q0_975_TailleS = c(rep(NA,length(unique(TABLEAU$gen))))

Median_TailleR = c(rep(NA,length(unique(TABLEAU$gen))))
Q0_025_TailleR = c(rep(NA,length(unique(TABLEAU$gen))))
Q0_975_TailleR = c(rep(NA,length(unique(TABLEAU$gen))))

for (i in 1:length(Median_PropC)){
  Median_PropC[i] = quantile(TABLEAU$PropC[TABLEAU$gen == unique(TABLEAU$gen)[i]], probs = 0.5, na.rm = TRUE)
  Q0_025_PropC[i] = quantile(TABLEAU$PropC[TABLEAU$gen == unique(TABLEAU$gen)[i]], probs = 0.025, na.rm = TRUE)
  Q0_975_PropC[i] = quantile(TABLEAU$PropC[TABLEAU$gen == unique(TABLEAU$gen)[i]],probs = 0.975, na.rm = TRUE)
  
  Median_TailleS[i] = quantile(TABLEAU$Taille_pop_S[TABLEAU$gen == unique(TABLEAU$gen)[i]], probs = 0.5, na.rm = TRUE)
  Q0_025_TailleS[i] = quantile(TABLEAU$Taille_pop_S[TABLEAU$gen == unique(TABLEAU$gen)[i]], probs = 0.025, na.rm = TRUE)
  Q0_975_TailleS[i] = quantile(TABLEAU$Taille_pop_S[TABLEAU$gen == unique(TABLEAU$gen)[i]],probs = 0.975, na.rm = TRUE)
  
  Median_TailleR[i] = quantile(TABLEAU$Taille_pop_R[TABLEAU$gen == unique(TABLEAU$gen)[i]], probs = 0.5, na.rm = TRUE)
  Q0_025_TailleR[i] = quantile(TABLEAU$Taille_pop_R[TABLEAU$gen == unique(TABLEAU$gen)[i]], probs = 0.025, na.rm = TRUE)
  Q0_975_TailleR[i] = quantile(TABLEAU$Taille_pop_R[TABLEAU$gen == unique(TABLEAU$gen)[i]],probs = 0.975, na.rm = TRUE)
}
```

Implementation of data table with the rescaling of the proportion of virulent allele ([0,1]) to the same scale on the y axis that the population sizes ([0,90000])

```{r Scaling of the virulent allele proportion on the population size scale}
Tab_results = as.data.frame(cbind(unique(TABLEAU$gen), Median_PropC, Q0_025_PropC,Q0_975_PropC, Median_TailleS, Q0_025_TailleS, Q0_975_TailleS, Median_TailleR, Q0_025_TailleR, Q0_975_TailleR))

Tab_results$Median_PropC_bis <- Tab_results$Median_PropC * 90000
Tab_results$Q0_025_PropC_bis <- Tab_results$Q0_025_PropC * 90000
Tab_results$Q0_975_PropC_bis <- Tab_results$Q0_975_PropC * 90000
```

For all replicates with a fixation of the virulent allele before the end of the simulation, replacement of the NA following the generation of fixation by the last value, to extend the values until generation 300 (the limit chosen for the graph).
```{r Replacement of NAs}
nom_colonnes = colnames(Tab_results)

if (is.na(Tab_results$Median_PropC[Tab_results$V1==297])){
  # If the data for last generation before the generation 300 is NA, we replace it by the last value before any NA
  iterateur = 0
  while (iterateur<=300){
    if (!is.na(Tab_results$Median_PropC[Tab_results$V1==iterateur])){
      ligne = Tab_results[Tab_results$V1==iterateur,nom_colonnes[c(2:length(nom_colonnes))]]
    }else{
      Tab_results[Tab_results$V1==iterateur,]=c(iterateur,ligne)
    }
    iterateur = iterateur+11
  }
}
```

Graphics export, with median and confidence intervals at 95%, for the evolution of the virulent allele frequency and the population sizes through generations.

```{r Graphics of the allelic and demographic evolution}
p_evol = eval(substitute(ggplot(Tab_results, aes(x = V1, y = Median_TailleS)) +
  scale_x_continuous(limits = c(-22,300), name = "Generation") +
  scale_y_continuous(name = "Number of individuals",expand = c(0,0), limits = c(0,90000), sec.axis = sec_axis( trans=~./90000, #name="Proportion of virulent allele"
                                                                                                               name="")) +
  geom_ribbon(aes(ymin=Q0_025_TailleS, ymax=Q0_975_TailleS),fill=rgb(1, 0.4, 0, 0.1))+
  geom_ribbon(aes(ymin=Q0_025_TailleR, ymax=Q0_975_TailleR),fill=rgb(0, 0, 1, 0.1))+
  geom_ribbon(aes(ymin=Q0_025_PropC_bis, ymax=Q0_975_PropC_bis),fill=rgb(1, 0, 0, 0.1))+
  geom_line(col = "orange", size = 1.2)+
  geom_line(aes(y = Median_TailleR), col = "darkblue", size = 1.2)+
  geom_line(aes(y = Median_PropC_bis), col = "red", size = 1.2)+
  geom_hline(yintercept=0)+
  geom_vline(xintercept=0, linetype = "dashed", size= 1.1)+
  theme_classic()+
  labs(title = "Without host alternation")+
  theme(plot.background = element_rect(fill = "transparent"),
        #plot.margin = unit(c(2,0,1,1),units="lines"), 
        axis.text.y = element_text(angle = 90, hjust = 0.5, vjust = 1, size=13),
        axis.text.y.right = element_text(angle = 0, vjust=0.5, size=13, color = "red"),
        axis.text.x = element_text(size=13),
        axis.title.x = element_text(size=13),
        axis.title.y = element_text(color = "black", size=13),
        axis.title.y.right = element_text(color = "red", size=13, angle = 90),
        plot.title = element_text(face = "bold", hjust=0.5))))

pdf(paste(directory_figures,"Evol_avr_propR09_without_alt.pdf", sep=""), width = 6, height = 4)
  p_evol
dev.off()
```

# Graphics based on the regular design

## Representation of the simulation results

```{r Simulation results at equilibrium among replicates}
# Keep only replicates with mig=0.05, and diploids. To adapt to study other combinations of parameters 
Tableau_fixation_contour_plot = subset(Tableau_fixation, Tableau_fixation$mig == 0.05 & Tableau_fixation$ploidie=="dip") 

# The size of the point will depend on the number of replicates reaching an equilibrium (extinction, or fixation of one allele)
Tableau_fixation_contour_plot$Colonne_graphique_taille = 1 - Tableau_fixation_contour_plot$freq_eq

# Calculation of new proportions of extinctions and fixations without the replicates with a coexistence of the two alleles at the end of the simulation (equilibrium not reached)
Tableau_fixation_contour_plot$freq_fix_C_sans_eq = Tableau_fixation_contour_plot$freq_fix_C/Tableau_fixation_contour_plot$Colonne_graphique_taille
Tableau_fixation_contour_plot$freq_ext_sans_eq = Tableau_fixation_contour_plot$freq_ext/Tableau_fixation_contour_plot$Colonne_graphique_taille

# Colors associated with the extinction or the fixation of the virulent allele
Tableau_fixation_contour_plot$Colonne_graphique_CT = ifelse(Tableau_fixation_contour_plot$freq_ext_sans_eq!=0, NA,1-Tableau_fixation_contour_plot$freq_fix_C_sans_eq)
Tableau_fixation_contour_plot$Colonne_graphique_CExt = ifelse(Tableau_fixation_contour_plot$freq_ext_sans_eq==0, NA, Tableau_fixation_contour_plot$freq_ext_sans_eq)
Tableau_fixation_contour_plot$Colonne_graphique = ifelse(Tableau_fixation_contour_plot$freq_ext_sans_eq!=0, -Tableau_fixation_contour_plot$freq_ext_sans_eq,1-Tableau_fixation_contour_plot$freq_fix_C_sans_eq)

Tableau_fixation_contour_plot$cycleNom = ifelse(Tableau_fixation_contour_plot$cycle=="Avec_Meleze", "With host alternation", "Without host alternation")

# Graphics

p1 = eval(substitute(ggplot(subset(Tableau_fixation_contour_plot, propR == 0.1 & cycleNom == "Without host alternation")) + 
  geom_point(aes(x = as.factor(frequence) , y = r, color = Colonne_graphique, cex = Colonne_graphique_taille))+
  scale_size_continuous(limits = c(0,1), range = c(0, 4))+
  xlab("favr") + 
  ylab("Growth rate r") +
  scale_color_gradient2("Results", low = "black", mid = "red", midpoint = 0, high = "blue")+
  labs(title="Without host alternation")+
  theme(legend.position = "none")+
  theme(axis.title.x=element_blank()) + 
  geom_hline(yintercept = 1.235, colour = "black") +
  scale_y_continuous(breaks = seq(1.1, 2, by = 0.2), limits = c(1.1,2))+
  theme(plot.background = element_rect(fill = "transparent"),
        #plot.margin = unit(c(2,0,1,1),units="lines"), 
        axis.text.x = element_text(size=12),
        axis.text.y = element_text(size=12),
        axis.title.x = element_text(size=13),
        axis.title.y = element_text(color = "black", size=13),
        plot.title = element_text(face = "bold", hjust=0.5))))

p2 = eval(substitute(ggplot(subset(Tableau_fixation_contour_plot, propR == 0.1 & cycleNom == "With host alternation")) + 
  geom_point(aes(x = as.factor(frequence) , y = r, color = Colonne_graphique, cex = Colonne_graphique_taille))+
  scale_size_continuous(limits = c(0,1), range = c(0, 4))+
  xlab("favr") + 
  ylab("") +
  scale_color_gradient2("Results", low = "black", mid = "red", midpoint = 0, high = "blue")+
  labs(title="With host alternation")+
  theme(legend.position = "none")+
  theme(axis.title.x=element_blank()) + 
  geom_hline(yintercept = 1.242, colour = "black") +
  scale_y_continuous(breaks = seq(1.1, 2, by = 0.2), limits = c(1.1,2))+
  theme(plot.background = element_rect(fill = "transparent"),
        #plot.margin = unit(c(2,0,1,1),units="lines"), 
        axis.text.x = element_text(size=12),
        axis.title.x = element_text(size=13),
        axis.text.y = element_text(size=12),
        axis.title.y = element_text(color = "black", size=13),
        plot.title = element_text(face = "bold", hjust=0.5))))

p3 = eval(substitute(ggplot(subset(Tableau_fixation_contour_plot, propR == 0.5 & cycleNom == "Without host alternation")) + 
  geom_point(aes(x = as.factor(frequence) , y = r, color = Colonne_graphique, cex = Colonne_graphique_taille))+
  scale_size_continuous(limits = c(0,1), range = c(0, 4))+
  xlab("favr") + 
  ylab("Growth rate r") +
  scale_color_gradient2("Results", low = "black", mid = "red", midpoint = 0, high = "blue")+
  labs(title="Without host alternation")+
  theme(legend.position = "none")+
  theme(axis.title.x=element_blank()) + 
  geom_hline(yintercept = 1.235, colour = "black") +
  scale_y_continuous(breaks = seq(1.1, 2, by = 0.2), limits = c(1.1,2))+
  theme(plot.background = element_rect(fill = "transparent"),
        #plot.margin = unit(c(2,0,1,1),units="lines"), 
        axis.text.x = element_text(size=12),
        axis.title.x = element_text(size=13),
        axis.text.y = element_text(size=12),
        axis.title.y = element_text(color = "black", size=13),
        plot.title = element_text(face = "bold", hjust=0.5))))

p4 = eval(substitute(ggplot(subset(Tableau_fixation_contour_plot, propR == 0.5 & cycleNom == "With host alternation")) + 
  geom_point(aes(x = as.factor(frequence) , y = r, color = Colonne_graphique, cex = Colonne_graphique_taille))+
  scale_size_continuous(limits = c(0,1), range = c(0, 4))+
  xlab("favr") + 
  ylab("") +
  scale_color_gradient2("Results", low = "black", mid = "red", midpoint = 0, high = "blue")+
  labs(title="With host alternation")+
  theme(legend.position = "none")+
  theme(axis.title.x=element_blank()) + 
  geom_hline(yintercept = 1.317, colour = "black") +
  scale_y_continuous(breaks = seq(1.1, 2, by = 0.2), limits = c(1.1,2))+
  theme(plot.background = element_rect(fill = "transparent"),
        #plot.margin = unit(c(2,0,1,1),units="lines"), 
        axis.text.x = element_text(size=12),
        axis.title.x = element_text(size=13),
        axis.text.y = element_text(size=12),
        axis.title.y = element_text(color = "black", size=13),
        plot.title = element_text(face = "bold", hjust=0.5))))

p5 = eval(substitute(ggplot(subset(Tableau_fixation_contour_plot, propR == 0.9 & cycleNom == "Without host alternation")) + 
  geom_point(aes(x = as.factor(frequence) , y = r, color = Colonne_graphique, cex = Colonne_graphique_taille))+
  scale_size_continuous(limits = c(0,1), range = c(0, 4))+
  xlab("favr") + 
  ylab("Growth rate r") +
  scale_color_gradient2("Results", low = "black", mid = "red", midpoint = 0, high = "blue")+
  labs(title="Without host alternation")+
  theme(legend.position = "none")+
  theme(axis.title.x=element_blank()) + 
  geom_hline(yintercept = 1.236, colour = "black") +
  scale_y_continuous(breaks = seq(1.1, 2, by = 0.2), limits = c(1.1,2))+
  theme(plot.background = element_rect(fill = "transparent"),
        #plot.margin = unit(c(2,0,1,1),units="lines"), 
        axis.text.x = element_text(size=12),
        axis.title.x = element_text(size=13),
        axis.text.y = element_text(size=12),
        axis.title.y = element_text(color = "black", size=13),
        plot.title = element_text(face = "bold", hjust=0.5))))

p6 = eval(substitute(ggplot(subset(Tableau_fixation_contour_plot, propR == 0.9 & cycleNom == "With host alternation")) + 
  geom_point(aes(x = as.factor(frequence) , y = r, color = Colonne_graphique, cex = Colonne_graphique_taille))+
  scale_size_continuous(limits = c(0,1), range = c(0, 4))+
  xlab("favr") + 
  ylab("") +
  scale_color_gradient2("Results", low = "black", mid = "red", midpoint = 0, high = "blue")+
  labs(title="With host alternation")+
  theme(legend.position = "none")+
  theme(axis.title.x=element_blank()) + 
  geom_hline(yintercept = 1.548, colour = "black") +
  scale_y_continuous(breaks = seq(1.1, 2, by = 0.2), limits = c(1.1,2))+
  theme(plot.background = element_rect(fill = "transparent"),
        #plot.margin = unit(c(2,0,1,1),units="lines"), 
        axis.text.x = element_text(size=12),
        axis.text.y = element_text(size=12),
        axis.title.x = element_text(size=13),
        axis.title.y = element_text(color = "black", size=13),
        plot.title = element_text(face = "bold", hjust=0.5))))

pdf(paste(directory_figures,"contour_plot_propR01_dip.pdf", sep=""), width = 8, height = 3)
grid.arrange(grobs=list(p1,p2),ncol=2)
dev.off()

pdf(paste(directory_figures,"contour_plot_propR05_dip.pdf", sep=""), width = 8, height = 3)
grid.arrange(grobs=list(p3,p4),ncol=2)
dev.off()

pdf(paste(directory_figures,"contour_plot_propR09_dip.pdf", sep=""), width = 8, height = 3)
grid.arrange(grobs=list(p5,p6),ncol=2)
dev.off()
```


## Evolution of the frequency of fixation of the virulent allele

Graphics representing the proportion of fixation of the virulent allele depending on *propR* and *r*.

```{r Proportion of fixation of the virulent allele depending on propR and r}
# Keep only replicates with favr=0.0005. To adapt to study other combinations of parameters 
Tableau_fixation_restreint = Tableau_fixation[Tableau_fixation$frequence==0.0005,]

# List with all graphics, one per life cycle and per ploidy
plist = list()
p = 1
for (c in unique(Tableau_fixation_restreint$cycle)){
  for (ploid in unique(Tableau_fixation_restreint$ploidie)){
    Tableau_graphique = subset(Tableau_fixation_restreint, ploidie == ploid & cycle == c)
    limit_y = c(0,1.05)
    title_ploid = "Haploid, "
    title_cycle = "With host alternation"
    if (ploid=="dip"){
      limit_y = c(0,0.25)
      title_ploid = "Diploid, "
    }
    
    if (c=="Sans_Meleze"){
      title_cycle = "Without host alternation"
    }
    
    p1 = eval(substitute(ggplot() +
      geom_smooth(data = Tableau_graphique[Tableau_graphique$r == 1.1,], aes(x = propR, y = freq_fix_C), col = viridis(10)[10], fill = viridis(10)[10], alpha = 0.1, size = 1)+
      geom_smooth(data = Tableau_graphique[Tableau_graphique$r == 1.2,], aes(x = propR, y = freq_fix_C), col =  viridis(10)[9], fill = viridis(10)[9], alpha = 0.1, size = 1)+
      geom_smooth(data = Tableau_graphique[Tableau_graphique$r == 1.3,], aes(x = propR, y = freq_fix_C), col =  viridis(10)[8], fill = viridis(10)[8], alpha = 0.1, size = 1)+
      geom_smooth(data = Tableau_graphique[Tableau_graphique$r == 1.4,], aes(x = propR, y = freq_fix_C), col =  viridis(10)[7], fill = viridis(10)[7], alpha = 0.1, size = 1)+
      geom_smooth(data = Tableau_graphique[Tableau_graphique$r == 1.5,], aes(x = propR, y = freq_fix_C), col =  viridis(10)[6], fill = viridis(10)[6], alpha = 0.1, size = 1)+
      geom_smooth(data = Tableau_graphique[Tableau_graphique$r == 1.6,], aes(x = propR, y = freq_fix_C), col =  viridis(10)[5], fill = viridis(10)[5], alpha = 0.1, size = 1)+
      geom_smooth(data = Tableau_graphique[Tableau_graphique$r == 1.7,], aes(x = propR, y = freq_fix_C), col =  viridis(10)[4], fill = viridis(10)[4], alpha = 0.1, size = 1)+
      geom_smooth(data = Tableau_graphique[Tableau_graphique$r == 1.8,], aes(x = propR, y = freq_fix_C), col =  viridis(10)[3], fill = viridis(10)[3], alpha = 0.1, size = 1)+
      geom_smooth(data = Tableau_graphique[Tableau_graphique$r == 1.9,], aes(x = propR, y = freq_fix_C), col = viridis(10)[2], fill = viridis(10)[2], alpha = 0.1, size = 1)+
      geom_smooth(data = Tableau_graphique[Tableau_graphique$r == 2.0,], aes(x = propR, y = freq_fix_C), col = viridis(10)[1], fill = viridis(10)[1], alpha = 0.1, size = 1)+
      scale_x_continuous(expand = c(0,0),limits = c(0, 1), name="propR") +
      scale_y_continuous(expand = c(0,0), limits = c(-1,1.2), name = "frequency of fixation of avr") +
      coord_cartesian(xlim=c(0,1), ylim=limit_y) +
      theme_classic()+
      geom_vline(xintercept=0.05, linetype = "dashed", size= 0.8)+
      geom_vline(xintercept=0.95, linetype = "dashed", size= 0.8)+
      labs(title=paste(title_ploid, title_cycle, sep=""))+
      theme(plot.background = element_rect(fill = "transparent"),
            #plot.margin = unit(c(2,0,1,1),units="lines"), 
            axis.text.y = element_text(size=13),
            plot.title = element_text(face = "bold", hjust=0.5, size=13),
            axis.title.x = element_text(size=13),
            axis.title.y = element_text(color = "black", size=13),
            axis.text.x = element_text(size=13))))
    
    plist[[p]] = p1
    p=p+1
  }
}

# With host alternation, diploid
pdf(paste(directory_figures,"Fixation_propR_with_alt_dip.pdf",sep=""), width = 6, height = 4)
plist[1]
dev.off()

# With host alternation, haploid
pdf(paste(directory_figures,"Fixation_propR_with_alt_hap.pdf",sep=""), width = 6, height = 4)
plist[2]
dev.off()

# Without host alternation, diploid
pdf(paste(directory_figures,"Fixation_propR_without_alt_dip.pdf",sep=""), width = 6, height = 4)
plist[3]
dev.off()

# Without host alternation, haploid
pdf(paste(directory_figures,"Fixation_propR_without_alt_hap.pdf",sep=""), width = 6, height = 4)
plist[4]
dev.off()
```